
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.ExecutionException;

/**
   Implement this task graph on a thread pool with
   just one worker thread. What happens? Why?

       task1         task2
            \       /
             \     /
              task3
*/
public class TaskGraph_v1_deadlock
{
   public static void main(String[] args)
   {
      final int cores = 1;
      final MyThreadPool_v1 executor = new MyThreadPool_v1(cores);

      final Task<Integer,Integer> task1 = new Task<>(1, 1, 1);
      final Task<Integer,Integer> task2 = new Task<>(2, 2, 3);
      final Task<Integer,Integer> task3 = new Task<>(3, 3, 2);

      final CompletableFuture<Integer> future = new CompletableFuture<>(); // empty future

      final Runnable r1 = ()->{try{ task1.run();
                                    future.get(); // Receive a message.
                                    task3.run();
                                  }catch(InterruptedException
                                        |ExecutionException e){}
                              };

      final Runnable r2 = ()->{ task2.run();
                                future.complete(0); // Send a message.
                              };

      executor.execute( r1 );
      executor.execute( r2 );

      executor.shutdown();
   }
}
